Index: /main/trunk/greenstone2/macros/nepali.dm
===================================================================
--- /main/trunk/greenstone2/macros/nepali.dm	(revision 22366)
+++ /main/trunk/greenstone2/macros/nepali.dm	(revision 22367)
@@ -181,5 +181,5 @@
 _pages_ [l=ne] {à€ªà¥à€·à¥à€ }
 _of_ [l=ne] {à€à¥ }
-_vol_ [l=ne] {à€à€£à¥à€¡}
+_vol_ [l=ne] {à€à€£à¥à€¡}  
 _num_ [l=ne] {à€žà€à€à¥à€¯à€Ÿ}
 
@@ -202,5 +202,5 @@
 
 _texttext_ [l=ne] {à€²à¥à€ }  
-
+_labeltext_ [l=ne] {_texttext_}  
 _textdocument_ [l=ne] {à€Šà€žà¥à€€à€Ÿà€µà¥à€}
 _textsection_ [l=ne] {à€­à€Ÿà€}
@@ -327,5 +327,5 @@
 _texticoncont_ [l=ne] {à€šà€¿à€°à€šà¥à€€à€° ?}  
 
-_textltwarning_ [l=ne] {   <div class="buttons">_imagecont_</div>
+_textltwarning_ [l=ne] {<div class="buttons">_imagecont_</div>
 _iconwarning_ à€¯à¥ à€¶à€¬à¥à€Šà€²à€Ÿà€ à€¬à€¿à€žà¥à€€à€Ÿà€° à€à€°à¥à€šà¥à€­à€à€®à€Ÿ à€€à€ªà€Ÿà€à€à¥ à€¬à¥à€°à€Ÿà€à€à€° à€Šà¥à€à€Ÿà€à€šà¥ à€­à€šà¥à€Šà€Ÿ à€¬à€¢à¥ à€¬à€¿à€µà€°à€£ à€à€€à¥à€ªà€šà¥à€š à€¹à¥à€šà¥à€ à¥€}  
 
@@ -416,6 +416,6 @@
 }  
 _textinfield_ [l=ne] {âŠà€à¥à€·à¥à€€à¥à€°à€®à€Ÿ}
-
-
+_textfieldphrase_ [l=ne] {à€à¥à€·à¥à€€à¥à€°}  
+_textinwords_ [l=ne] {âŠ.à€¶à€¬à¥à€Š(à€¹à€°à¥)à€®à€Ÿ}  
 _textfoldstem_ [l=ne] {(à€Šà¥à€¬à¥à€¬à¥à€°à€Ÿà€à€šà¥ à€ªà¥à€°à€£à€Ÿà€²à¥ )}  
 
@@ -435,5 +435,6 @@
 
 _textsimplesearch_ [l=ne] {à€à¥à€à€šà¥à€žà¥ : _indexselection_ à€®à€Ÿ _If_(_jselection_, _jselection_à€žà€à€ à€žà€®à¥à€¬à€šà¥à€§à€¿à€€)_If_(_gselection_,à€®à€Ÿ _gselection_ à€€à€¹)_If_(_nselection_,   _nselection_ à€­à€Ÿà€·à€Ÿà€®à€Ÿ)_If_(_sfselection_,\,_allowformbreak_ , à€à€€à€° _sfselection_ à€à¥ à€à€§à€Ÿà€°à€®à€Ÿ )   _querytypeselection_ à€à¥ à€¶à€¬à¥à€Šà€¹à€°à¥}  
-
+_textsimplesqlsearch_ [l=ne] {à€à¥à€à¥à€šà¥à€ž :  _indexselection_ à€®à€Ÿ _If_(_jselection_,  _jselection_à€žà€à€ à€žà€à€¬à€Šà¥à€§ )_If_(_gselection_,_gselection_ à€€à€¹à€®à€Ÿ )_If_(_nselection_,  _nselection_à€­à€Ÿà€·à€Ÿà€®à€Ÿ)_If_(_sqlsfselection_,\,_allowformbreak_ à€ªà€°à€¿à€£à€Ÿà€®_sqlsfselection_à€Šà¥à€µà€Ÿà€°à€Ÿ à€à€Ÿà€à¥à€šà¥)  _querytypeselection_ à€¶à€¬à¥à€Šà€¹à€°à¥à€à¥ à€²à€Ÿà€à€¿  
+}  
 
 _textadvancedsearch_ [l=ne] {à€à¥à€à€šà¥à€žà¥ : _indexselection__If_(_jselection_,  _jselection_ à€®à€Ÿ à€žà€®à¥à€¬à€§à€¿à€€)_If_(_gformselection_,_gformselection_à€€à€¹à€®à€Ÿ )_If_(_nselection_,   _nselection_ à€­à€Ÿà€·à€Ÿà€®à€Ÿ ) _querytypeselection_ à€ªà¥à€°à€¶à¥à€š à€ªà¥à€°à€¯à¥à€  à€à€°à€¿ }  
@@ -442,15 +443,15 @@
 
 _textadvancedlucenesearch_ [l=ne] {à€à¥à€à€šà¥à€žà¥ : _indexselection__If_(_jselection_,  _jselection_ à€®à€Ÿ à€žà€®à¥à€¬à€§à€¿à€€)_If_(_gformselection_,_gformselection_à€€à€¹à€®à€Ÿ )_If_(_nselection_,   _nselection_ à€­à€Ÿà€·à€Ÿà€®à€Ÿ )_If_(_sfselection_,\,_allowformbreak_  _sfselection_ \, ) à€€à€µà€°à€²à¥  , à€à¥ à€šà€¿à€®à¥à€€à€¿ }  
-
+_textadvancedsqlsearch_ [l=ne] {à€à¥à€à¥à€šà¥à€ž :  _indexselection__If_(_jselection_,  _jselection_à€žà€à€ à€žà€à€¬à€Šà¥à€§ )_If_(_gselection_,  _gselection_ à€€à€¹à€®à€Ÿ )_If_(_nselection_,_nselection_ à€­à€Ÿà€·à€Ÿà€®à€Ÿ)_If_(_sqlsfselection_,\,_allowformbreak_ à€ªà€°à€¿à€£à€Ÿà€® _sqlsfselection_\, à€Šà¥à€µà€Ÿà€°à€Ÿ à€à€Ÿà€à¥à€šà¥ ) à€à¥ à€²à€Ÿà€à€¿}  
 
 # the space after "Search" is required, otherwise no space between "Search" and "in"
 
 _textformsimplesearch_ [l=ne] {à€à¥à€à€šà¥à€žà¥ : _If_(_jselection_,  _jselection_ à€®à€Ÿ )_If_(_gformselection_,_gformselection_ à€€à€¹à€®à€Ÿ )_If_(_nselection_,   _nselection_ à€­à€Ÿà€·à€Ÿà€®à€Ÿ )_If_(_sfselection_,\, à€à€€à€° _sfselection_ à€à¥ à€à€§à€Ÿà€°à€®à€Ÿ )   _querytypesimpleselection_ à€à¥}  
-
+_textformsimplesearchsql_ [l=ne] {à€à¥à€à¥à€šà¥à€ž :  _If_(_jselection_,  _jselection_à€®à€Ÿ )_If_(_gformselection_, _gformselection_à€€à€¹à€®à€Ÿl )_If_(_nselection_, _nselection_à€­à€Ÿà€·à€Ÿà€®à€Ÿ)_If_(_sqlsfselection_,\, à€ªà€°à€¿à€£à€Ÿà€® _sqlsfselection_\, à€Šà¥à€µà€Ÿà€°à€Ÿ à€à€Ÿà€à¥à€šà¥ ) à€²à€Ÿà€à€¿ _formquerytypesimpleselection_ à€à¥ }  
 
 _textformadvancedsearchmgpp_ [l=ne] {à€à¥à€à€šà¥à€žà¥ : _If_(_jselection_,  _jselection_ à€®à€Ÿ )_If_(_gformselection_,_gformselection_à€€à€¹à€®à€Ÿ )_If_(_nselection_,   _nselection_ à€­à€Ÿà€·à€Ÿà€®à€Ÿ ) à€° à€à€€à€°  _querytypesimpleselection_ à€€à€°à€¿à€à€Ÿà€®à€Ÿ :}  
 
 _textformadvancedsearchlucene_ [l=ne] {à€à¥à€à€šà¥à€žà¥ : _If_(_jselection_,  _jselection_ à€®à€Ÿ )_If_(_gformselection_,_gformselection_à€€à€¹à€®à€Ÿ )_If_(_nselection_,   _nselection_ à€­à€Ÿà€·à€Ÿà€®à€Ÿ ) _If_(_sfselection_,\, à€à€€à€°  _sfselection_ \,) à€€à€°à€¿à€à€Ÿà€®à€Ÿ : }  
-
+_textformadvancedsearchsql_ [l=ne] {à€à¥à€à¥à€šà¥à€ž :  _If_(_jselection_, _jselection_à€®à€Ÿ )_If_(_gformselection_,  _gformselection_ à€€à€¹à€®à€Ÿ )_If_(_nselection_, _nselection_ à€­à€Ÿà€·à€Ÿà€®à€Ÿ)_If_(_sqlsfselection_,\, à€ªà€°à€¿à€£à€Ÿà€® _sqlsfselection_\,à€Šà¥à€µà€Ÿà€°à€Ÿ à€à€Ÿà€à¥à€šà¥ ) à€à¥ à€²à€Ÿà€à€¿}  
 
 _textnojsformwarning_ [l=ne] {à€žà€Ÿà€µà€§à€Ÿà€šà¥ à€€à€ªà€Ÿà€à€à¥ Web à€à€šà¥à€à€®à€Ÿ à€à€Ÿà€­à€Ÿ ( Java ) script à€€à€ªà€Ÿà€à€à¥ web à€Šà€žà¥à€€à€Ÿà€µà¥à€à€®à€Ÿ disabled à€ à¥€ à€€à¥à€¯à€žà¥à€²à¥ à€à¥à€à€®à€Ÿ à€¯à¥ à€ªà€Ÿà€à€šà¥ à€à¥à€š à¥€ }  
@@ -495,5 +496,5 @@
 #------------------------------------------------------------
 
-_textprefschanged_ [l=ne] { à€ªà¥à€°à€Ÿà€¥à€®à€¿à€à€€à€Ÿà€¹à€°à¥ à€¯à€ž à€ªà¥à€°à€à€Ÿà€°à€²à¥ à€µà¥à€¯à€µà€žà¥à€¥à€¿à€€ à€à€°à€¿à€à€à¥ à€ à¥€ à€€à€ªà€Ÿà€à€à¥ à€¬à¥à€°à€Ÿà€à€à€°à€à¥ "back" à€¬à€à€š à€ªà¥à€°à€¯à¥à€ à€šà€à€°à¥à€šà¥à€¹à¥à€²à€Ÿ - à€à€žà€²à¥ à€€à€ªà€Ÿà€à€à¥ à€ªà¥à€°à¥à€µ-à€µà¥à€¯à€µà€¥à€Ÿà€²à€Ÿà€ à€¹à€à€Ÿà€à€šà¥à€ à¥€ à€¬à€°à¥, à€®à€Ÿà€¥à€¿à€à¥ à€à€žà¥à€ž à€¬à€Ÿà€°à€à¥ à€à€à€à€Ÿ à€¬à€à€š à€¥à€¿à€à¥à€šà¥à€¹à¥à€ž à¥€}  
+_textprefschanged_ [l=ne] {à€ªà¥à€°à€Ÿà€¥à€®à€¿à€à€€à€Ÿà€¹à€°à¥ à€¯à€ž à€ªà¥à€°à€à€Ÿà€°à€²à¥ à€µà¥à€¯à€µà€žà¥à€¥à€¿à€€ à€à€°à€¿à€à€à¥ à€ à¥€ à€€à€ªà€Ÿà€à€à¥ à€¬à¥à€°à€Ÿà€à€à€°à€à¥ "back" à€¬à€à€š à€ªà¥à€°à€¯à¥à€ à€šà€à€°à¥à€šà¥à€¹à¥à€²à€Ÿ - à€à€žà€²à¥ à€€à€ªà€Ÿà€à€à¥ à€ªà¥à€°à¥à€µ-à€µà¥à€¯à€µà€¥à€Ÿà€²à€Ÿà€ à€¹à€à€Ÿà€à€šà¥à€ à¥€ à€¬à€°à¥, à€®à€Ÿà€¥à€¿à€à¥ à€à€žà¥à€ž à€¬à€Ÿà€°à€à¥ à€à€à€à€Ÿ à€¬à€à€š à€¥à€¿à€à¥à€šà¥à€¹à¥à€ž à¥€}  
 _textsetprefs_ [l=ne] {à€ªà¥à€°à€Ÿà€¥à€®à€¿à€à€€à€Ÿ à€€à¥à€à¥à€šà¥à€¹à¥à€žà¥}
 _textsearchprefs_ [l=ne] {à€à¥à€à¥à€šà¥ à€ªà¥à€°à€Ÿà€¥à€®à€¿à€à€€à€Ÿà€¹à€°à¥}
@@ -533,5 +534,5 @@
 _textsearchtype_ [l=ne] {à€ªà¥à€°à€¶à¥à€š à€¶à¥à€²à¥:}
 _textformsearchtype_ [l=ne] {à€ à€Ÿà€à€ ( à€žà¥à€¥à€š ) à€žà€à€ formnumfieldoption à€žà¥à€¥à€Ÿà€šà€à¥ à€¬à€¿à€à€²à¥à€ª à€žà¥à€¥à€š }  
-
+_textsqlformsearchtype_ [l=ne] {SQL à€à¥à€·à¥à€€à¥à€° à€žà€à€  _sqlformnumfiledoption_ à€à¥à€·à¥à€€à¥à€°à€¹à€°à¥ }  
 _textplainsearchtype_ [l=ne] {_boxsizeoption_ à€ªà¥à€°à€¶à¥à€š à€à¥à€µà¥à€°à¥ à€¬à€à¥à€ž à€à¥ à€žà€Ÿà€¥ à€žà€Ÿà€®à€Ÿà€šà¥à€¯}  
 _textregularbox_ [l=ne] {à€à€ à€¹à€°à€«}
@@ -607,6 +608,5 @@
 _textreadingdocs_ [l=ne] {à€Šà€žà¥à€€à€Ÿà€µà¥à€ à€à€žà€°à¥ à€ªà€¢à¥à€šà¥ }
 
-_texthelpreadingdocs_ [l=ne] {
-<p>à€à€ à€ªà¥à€žà¥à€€à€ à€µà€Ÿ à€Šà€žà¥à€€à€Ÿà€µà¥à€à€Œà€®à€Ÿ à€€à€ªà€Ÿà€ à€ªà¥à€à¥à€šà¥à€­à€¯à¥ à€­à€šà¥ à€€à€ªà€Ÿà€ à€à€«à¥à€²à¥ à€à€Ÿà€² à€ªà€Ÿà€à€šà¥ à€¹à¥à€šà¥à€ à€à€¿à€šà€à€¿ à€€à¥à€¯à¥ à€ªà¥à€žà¥à€€à€à€à¥ à€¶à¥à€°à¥à€·à€, à€µà€Ÿ à€
+_texthelpreadingdocs_ [l=ne] {<p>à€à€ à€ªà¥à€žà¥à€€à€ à€µà€Ÿ à€Šà€žà¥à€€à€Ÿà€µà¥à€à€Œà€®à€Ÿ à€€à€ªà€Ÿà€ à€ªà¥à€à¥à€šà¥à€­à€¯à¥ à€­à€šà¥ à€€à€ªà€Ÿà€ à€à€«à¥à€²à¥ à€à€Ÿà€² à€ªà€Ÿà€à€šà¥ à€¹à¥à€šà¥à€ à€à€¿à€šà€à€¿ à€€à¥à€¯à¥ à€ªà¥à€žà¥à€€à€à€à¥ à€¶à¥à€°à¥à€·à€, à€µà€Ÿ à€
 à€à€¿à€²à¥à€²à¥ à€ªà¥à€·à¥à€à€à¥ à€€à€žà¥à€¬à€¿à€°, à€®à€Ÿà€¥à€¿à€²à¥à€²à¥ à€¬à€Ÿà€à€¯à€Ÿà€®à€Ÿ à€Šà¥à€à¥à€šà€žà€à¥à€šà¥ à€¹à¥à€šà¥à€à¥€  à€à¥à€šà¥-à€à¥à€šà¥ à€žà€à€à¥à€°à€¹à€®à€Ÿ , à€žà€Ÿà€®à€à¥à€°à¥ à€€à€Ÿà€²à€¿à€à€Ÿ à€Šà€¿à€à¥à€š à€žà€à€¿à€šà¥à€, à€à€¬à€à€¿ à€
 à€šà¥à€¯à€®à€Ÿ à€ªà¥à€·à¥à€  à€žà€à€à¥à€¯à€Ÿ à€®à€Ÿà€€à¥à€° à€Šà¥à€à€Ÿà€à€šà¥à€ à€žà€Ÿà€¥à€®à€Ÿ à€šà€à€¯à€Ÿ à€ªà¥à€·à¥à€  à€à€šà¥à€, à€
@@ -748,5 +748,5 @@
 à€šà¥à€žà€Ÿà€°à€à¥ à€à¥à€}
 
-_texthelpformsearch_ [l=ne] { à€à¥à€à¥à€°à€¹à¥à€à¥ à€à¥à€·à¥à€€à¥à€°à€²à¥ à€à¥à€à€à¥ à€žà€¿à€®à€Ÿ à€šà€Ÿà€à¥à€šà€²à€Ÿà€ à€®à¥à€à€Ÿ à€ªà¥à€°à€Šà€Ÿà€š à€à€°à¥à€Šà€ à¥€  à€à€žà¥à€€à¥ à€à€Šà€Ÿà€¹à€°à€£ à€à€à€à€Ÿà€²à¥ AND à€¶à€¿à€°à¥à€·à€à€®à€Ÿ à€žà¥à€®à€¿à€€ ( smith ) à€­à€šà¥à€šà¥ à€à¥à€ à€°à€Ÿà€à¥à€¯à¥ à¥€ à€žà€Ÿà€§à€Ÿà€°à€£ query  à€à¥ à€€à€°à¥à€à€Ÿ à€®à€Ÿ à€ªà¥à€°à€€à¥à€¯à¥à€ à€²à€Ÿà€à€šà€®à€Ÿ à€à€žà€à¥ à€µà¥à€¯à€µà€¹à€Ÿà€°à€²à¥ à€žà€®à€Ÿà€šà¥à€¯ à€à€à€à€Ÿà€®à€Ÿà€€à¥à€° à€²à€Ÿà€à€š ( à€§à€žà¥à€°à¥ ) à€Šà¥à€à€¿à€¯à¥ à¥€ à€µà¥à€¯à€à¥à€€à€¿à€à€€ à€°à¥à€ªà€²à¥ à€°à€Ÿà€à¥à€à¥ à€§à€°à¥à€à¥à€²à€Ÿà€ à€žà€à€¯à¥à€à€š à€à€°à¥ à€ªà¥à€°à€¯à¥à€ à€à€°à€¿à€¹à€šà¥ à€° ( à€žà€¬à¥ à€à¥à€à€®à€Ÿ ) à€
+_texthelpformsearch_ [l=ne] {à€à¥à€à¥à€°à€¹à¥à€à¥ à€à¥à€·à¥à€€à¥à€°à€²à¥ à€à¥à€à€à¥ à€žà€¿à€®à€Ÿ à€šà€Ÿà€à¥à€šà€²à€Ÿà€ à€®à¥à€à€Ÿ à€ªà¥à€°à€Šà€Ÿà€š à€à€°à¥à€Šà€ à¥€  à€à€žà¥à€€à¥ à€à€Šà€Ÿà€¹à€°à€£ à€à€à€à€Ÿà€²à¥ AND à€¶à€¿à€°à¥à€·à€à€®à€Ÿ à€žà¥à€®à€¿à€€ ( smith ) à€­à€šà¥à€šà¥ à€à¥à€ à€°à€Ÿà€à¥à€¯à¥ à¥€ à€žà€Ÿà€§à€Ÿà€°à€£ query  à€à¥ à€€à€°à¥à€à€Ÿ à€®à€Ÿ à€ªà¥à€°à€€à¥à€¯à¥à€ à€²à€Ÿà€à€šà€®à€Ÿ à€à€žà€à¥ à€µà¥à€¯à€µà€¹à€Ÿà€°à€²à¥ à€žà€®à€Ÿà€šà¥à€¯ à€à€à€à€Ÿà€®à€Ÿà€€à¥à€° à€²à€Ÿà€à€š ( à€§à€žà¥à€°à¥ ) à€Šà¥à€à€¿à€¯à¥ à¥€ à€µà¥à€¯à€à¥à€€à€¿à€à€€ à€°à¥à€ªà€²à¥ à€°à€Ÿà€à¥à€à¥ à€§à€°à¥à€à¥à€²à€Ÿà€ à€žà€à€¯à¥à€à€š à€à€°à¥ à€ªà¥à€°à€¯à¥à€ à€à€°à€¿à€¹à€šà¥ à€° ( à€žà€¬à¥ à€à¥à€à€®à€Ÿ ) à€
 à€¥à€µà€Ÿ ( à€à€žà¥à€€à¥ à€à¥à€à€à¥ à€²à€Ÿà€à€¿ ) à€€à¥à€¯à€¹à€¿  à€à¥à€·à¥à€€à¥à€° à€žà€à€ à€žà€®à¥à€¬à€šà¥à€§à€¿à€€ à€à¥à€à€à¥ à€¶à€°à¥à€€à€¹à€°à¥ à€ªà€šà€¿ à€žà€à€²à€à¥à€š à€ à¥€ à€€à¥à€¯à€¹à€Ÿà€ à€µà€¿à€à€Ÿà€žà€¿à€€ ( à€šà€¯à€Ÿà€ ) à€€à€°à¥à€à€Ÿà€à¥ à€žà€à€¯à¥à€à€š à€ªà€Ÿà€à€šà¥ à€¹à¥à€šà¥à€ à¥€
 
@@ -834,5 +834,5 @@
 }  
  
-_textstemoptionsprefs_ [l=ne] { "_texthelpquerytermstitle_".à€®à€Ÿ à€µà€°à¥à€£à€š à€à€°à€¿à€à€à¥ à€à¥à€à€à€Ÿ à€¶à€°à¥à€€ à€ªà¥à€°à€¯à¥à€ à€à€°à¥à€Šà€Ÿ à€žà¥à€µà€¿à€§à€à€Ÿà€šà€ à€° à€žà€à¥à€ à€¹à¥à€šà¥à€ à¥€ }  
+_textstemoptionsprefs_ [l=ne] {"_texthelpquerytermstitle_".à€®à€Ÿ à€µà€°à¥à€£à€š à€à€°à€¿à€à€à¥ à€à¥à€à€à€Ÿ à€¶à€°à¥à€€ à€ªà¥à€°à€¯à¥à€ à€à€°à¥à€Šà€Ÿ à€žà¥à€µà€¿à€§à€à€Ÿà€šà€ à€° à€žà€à¥à€ à€¹à¥à€šà¥à€ à¥€ }  
 
 _textsearchtypeprefsplain_ [l=ne] {à€ à¥à€²à€Ÿ à€à¥à€ à€à¥à€·à¥à€€à¥à€° à€ªà€Ÿà€à€š à€žà€à€­à€µ à€, à€€à¥à€¯à€žà¥à€²à¥ à€
@@ -855,5 +855,5 @@
 
 _texthelpscopetitle_ [l=ne] {à€à¥à€  à€à¥à€·à¥à€€à¥à€° ( à€à€°à€¿à€¯à€Ÿ ) }  
-_texthelpscope_ [l=ne] { à€ªà¥à€°à€Ÿà€¯ à€à€žà¥à€€à¥ à€à¥à€à¥à€à€Ÿ à€žà€à€à¥à€°à€¹à€®à€Ÿ à€€à€ªà€Ÿà€à€²à€Ÿà€ à€«à€°à€ à€µà€°à¥à€£à€à¥à€°à€® à€¬à€Ÿà€ à€à¥à€à¥à€šà¥ à€
+_texthelpscope_ [l=ne] {à€ªà¥à€°à€Ÿà€¯ à€à€žà¥à€€à¥ à€à¥à€à¥à€à€Ÿ à€žà€à€à¥à€°à€¹à€®à€Ÿ à€€à€ªà€Ÿà€à€²à€Ÿà€ à€«à€°à€ à€µà€°à¥à€£à€à¥à€°à€® à€¬à€Ÿà€ à€à¥à€à¥à€šà¥ à€
 à€µà€žà€° à€Šà€¿à€à€šà¥ à€ à¥€
 
Index: /main/trunk/greenstone2/macros/nepali2.dm
===================================================================
--- /main/trunk/greenstone2/macros/nepali2.dm	(revision 22366)
+++ /main/trunk/greenstone2/macros/nepali2.dm	(revision 22367)
@@ -92,5 +92,6 @@
 </ul> à€žà€à¥à€šà¥à€¹à¥à€šà¥à€ }  
 
-
+_text1coll_ [l=ne] {à€à¥à€šà€žà¥à€à¥à€š à€žà¥à€¥à€Ÿà€ªà€šà€Ÿà€®à€Ÿ à¥§ à€žà€à€à¥à€°à€¹ à€ à¥€
+}  
 
 _textmorecolls_ [l=ne] {à€¹à€°à€¿à€€à€¢à¥à€à€à€Ÿ à€®à€Ÿ _1_ à€žà€à€à¥à€°à€¹à€¹à€°à¥ à€à€šà¥ }  